using Gadgeteer.Interfaces.Fakes.Framework;
using System;
using System.Threading;

namespace Gadgeteer.Interfaces.Fakes
{
    public class FakeCamera : DelayedAction, ICamera
    {
        private static int unNamedButtons = 0;
        private PictureBuilder pictureBuilder = new PictureBuilder();

        public FakeCamera()
            : base("camera" + ++unNamedButtons)
        {
        }

        public void TakePicture()
        {
            ExecuteAsDelayed(TakeNextPicture, 
                new TimeSpan(0, 0, 0, 0, 100)
            );
        }

        private void TakeNextPicture()
        {
            var picture = pictureBuilder.NextPicture();
            OnPictureCaptured(picture);
        }

        private void OnPictureCaptured(Picture picture)
        {
            var ev = PictureCaptured;
            if (ev != null)
                ev(this, picture);
        }

        public event PictureCapturedEventHandler PictureCaptured;
    }
}
